require 'sketchup.rb'

$decidingVector90 = Geom::Vector3d.new

class FirstSSObserver < Sketchup::SelectionObserver
  ### A method for observing a selection change
    def onSelectionBulkChange (sel)
      ### Observer type 4
        #@secondObserver = SecondSSObserver.new
        n = FlatTool.getNormals
        FlatTool.decideWhetherHorizOrVert n
        FlatTool.getFlattenedEdgesAndFaces
        FlatTool.reverseReversedNormals
        #FlatTool.getFlattenedEdgesAndFaces
        #FlatTool.intersectWithSelf
        #FlatTool.getFlattenedEdgesAndFaces
        #FlatTool.intersectWithSelf
        #FlatTool.inner_edges_and_outer_edge_loop
        #FlatTool.edges_without_outer_edge_loop
        #Sketchup.active_model.selection.add_observer (@secondObserver)
      ### End
    end
  ### End
end

class FlatTool
  ### FlatTool class
    def FlatTool::vertices
      def vertices
        verts = []
        self.each do|e|
          verts.push e.vertices if (e.respond_to?(:vertices))
        end
        return verts.flatten.uniq
      end
    end
### ------------------------------------------------------------------------------------ ###
    def FlatTool::initialize
      @model = Sketchup.active_model
      @ss = @model.selection
      @ents = @model.entities
      @edges = []
      @edgesFaces = []
      @firstObserver = FirstSSObserver.new
      $oneNormalEdges = []
      $twoNormalEdges = []
      @usableEdges = []
      @usableFaces = []
      @allEdges = []
      @finalEdges = []
      @trunk = []
      if (($decidingVector90.x == 0) && ($decidingVector90.y == 0) && ($decidingVector90.z == 0))
        @nVert90 = Geom::Vector3d.new
      end
      FlatTool.vertices
    end
### ------------------------------------------------------------------------------------ ###
    def FlatTool::getverts
      FlatTool.initialize
      @verts = @ss.vertices
      Sketchup.active_model.selection.add_observer (@firstObserver)
    end
### ------------------------------------------------------------------------------------ ###
    def FlatTool::getNormals 
      ### So we can undo the whole shift and not each vert individually
        Sketchup.active_model.selection.remove_observer (@firstObserver)
        Sketchup.active_model.start_operation "Flatten"
        @proj_face = @ss[0]
        @proj_plane = @proj_face.plane
        @n = @proj_face.normal
        for i in 0..2
        if ((@n[i] >= -1) && (@n[i] < -0.9))
          @n[i] = -1
        elsif ((@n[i] > -0.1) && (@n[i] < 0.1))
          @n[i] = 0
        elsif ((@n[i] > 0.9) && (@n[i] <= 1))
          @n[i] = 1
        end
        end
        for i in 0..2
        if ((@n[i] >= -1) && (@n[i] < -0.9))
          @n[i] = -1
        elsif ((@n[i] > -0.1) && (@n[i] < 0.1))
          @n[i] = 0
        elsif ((@n[i] > 0.9) && (@n[i] <= 1))
          @n[i] = 1
        end
      end
      if (@n[2] > 0.2)
        @n = Geom::Vector3d.new(0,0,1)
      end
      if (@n[2] < -0.2)
        @n = Geom::Vector3d.new(0,0,-1)
      end
      @n.normalize!
      puts "@n = " + @n.to_s
      @n
      # End
    end
### ------------------------------------------------------------------------------------ ###
    def FlatTool::decideWhetherHorizOrVert (n)
      if ((n[2] == -1) || (n[2] == 1))
        @nHoriz = n
        puts "nHoriz = " + @nHoriz.to_s
        puts "projecting nHoriz..."
        FlatTool.project @nHoriz
      end
      if n[2] == 0
        if ((@nVert90.x == 0) && (@nVert90.y == 0) && (@nVert90.z == 0))
          puts "nVert90 before = " + @nVert90.to_s
          @nVert = n
          point = Geom::Point3d.new(0,0,0)
          vector = Geom::Vector3d.new(0,0,1)
          rads = (90 * (Math::PI/180))
          rotateNVert = Geom::Transformation.rotation point, vector, rads
          @nVert90 = @nVert.transform rotateNVert
          $decidingVector90 = Geom::Vector3d.new(1,1,1)
        end
        puts "nVert = " + @nVert.to_s
        puts "nVert90 = " + @nVert90.to_s
        angle0 = ((n.angle_between @nVert) * (180/Math::PI))
        angle1 = ((n.angle_between @nVert90) * (180/Math::PI))
        puts "angle between face normal and nVert = " + angle0.to_s
        puts "angle between face normal and nVert90 = " + angle1.to_s
        if (((angle0 > -30) && (angle0 < 30)) || ((angle0 > 150) && (angle0 < 210)))
          puts "projecting nVert..."
          FlatTool.project @nVert
        elsif (((angle1 > -30) && (angle1 < 30)) || ((angle1 > 150) && (angle1 < 210)))
          puts "projecting nVert90..."
          FlatTool.project @nVert90
        end
      end
    end
### ------------------------------------------------------------------------------------ ###
    def FlatTool::project (n)
      #The really important code!        
        @proj_plane_final = [@proj_face.vertices[0].position,n]
        @verts.each do |v|
          if not v.deleted?
            move_pt = v.position
            int_line = [move_pt,n]
            int_pt = Geom.intersect_line_plane int_line,@proj_plane_final
            vector_move = int_pt - move_pt
            #puts vector_move
            trans = Geom::Transformation.translation vector_move
            @ents.transform_entities(trans,v)
          end
          @n = n
        end
      ### End
    end
### ------------------------------------------------------------------------------------ ###
    def FlatTool::getFlattenedEdgesAndFaces
      puts "getting flattened edges and faces..."
      @ss.clear
      for v in @verts
        if (not v.deleted?)
          for e in v.edges
            @edges.push(e)
            for f in v.faces
              if (((f.normal[0] > (@n[0] - 0.1)) && (f.normal[0] < (@n[0] + 0.1))) && ((f.normal[1] > (@n[1] - 0.1)) && (f.normal[1] < (@n[1] + 0.1))) && ((f.normal[2] > (@n[2] - 0.1)) && (f.normal[2] < (@n[2] + 0.1))))
                @edges.push(f.edges)
              end
            end
          end
        end
      end
      @edges = @edges.flatten.uniq
      for e in @edges
        if ((not e.deleted?) && (e.hidden?))
          e.hidden= false
        end
      end
      for e in @edges
        #if (not e.deleted?)
          #for f in e.faces
            #if (not f.deleted?)
              @ss.add(e)
              #@ss.add(f)
            #end
          #end
        #end
      end
      for e in @ss
        if (e.kind_of?(Sketchup::Edge))
          @trunk.push(e)
        end
      end
    end
### ------------------------------------------------------------------------------------ ###
    def FlatTool::reverseReversedNormals
      puts "reversing normals..."
      @ss.each do |e|
        if ((e.kind_of?(Sketchup::Face)) && (e.normal == @n.reverse))
          e.reverse!
        end
      end
    end
### ------------------------------------------------------------------------------------ ###
    def FlatTool::intersectWithSelf
      puts "intersecting..."
      trans1 = Geom::Transformation.new
      #FlatTool.getFlattenedEdgesAndFaces
      #Sketchup.active_model.entities.intersect_with(true, trans1, @ents, [0,0,0], true, @ss.collect)
      #FlatTool.getFlattenedEdgesAndFaces
      Sketchup.active_model.commit_operation
      #@ss.clear
    end
### ------------------------------------------------------------------------------------ ###
    def FlatTool::inner_edges_and_outer_edge_loop
      ### A method for retrieving the flattened edges
        usableEdges = []
        usableFaces = []
        allEdges = []
        @finalEdges = []
        for e in @ss
          if ((e.kind_of?(Sketchup::Edge)) && (not e.deleted?) && (e.faces.length == 0))
            @ents.erase_entities (e)
          end
        end
        FlatTool.getFlattenedEdgesAndFaces
        for e in @ss
          if ((e.kind_of?(Sketchup::Face)) && (not e.deleted?))
            if (((e.normal[0] > (@n[0] - 0.1)) && (e.normal[0] < (@n[0] + 0.1))) && ((e.normal[1] > (@n[1] - 0.1)) && (e.normal[1] < (@n[1] + 0.1))) && ((e.normal[2] > (@n[2] - 0.1)) && (e.normal[2] < (@n[2] + 0.1))))
              usableFaces.push(e)
            end
          end
        end
        @ss.clear
        for f in usableFaces
          @ss.add(f)
          for e in f.edges
            @ss.add(e)
          end
        end
        #for e in @trunk
          #if (@ss.contains? e)
            #if e.faces.length == 0 
              #@ents.erase_entities (e)
          #end
          #elsif e.faces.length == 2
            #if ((e.faces[0].normal[0] > (@n[0] - 0.1))
            
          #if (not @ss.contains? e)
            #@ents.erase_entities (e)
          #end
        #end
        #for e in @ss
          #if ((e.kind_of?(Sketchup::Edge)) && (not e.deleted?))
            #usableEdges.push(e)
          #end
        #end
        #@ss.clear
        #for e in usableEdges
          #for v in e.faces
            #if v.normal == @n
              #usableFaces.push(v)
            #end
          #end
        #end
        #for e in usableFaces
          #allEdges.push(e.edges)
        #end
        #allEdges = allEdges.flatten.uniq
        #for e in allEdges
          #if (not e.deleted?)
            #@finalEdges.push(e)
          #end
        #end
        #for e in @finalEdges
          #if (e.hidden?)
            #e.hidden= false
          #end
        #end
        #for e in @finalEdges
          #for v in e.faces
            #if v.normal == @n
              #$oneNormalEdges.push(e)
            #else
              #$twoNormalEdges.push(e)
            #end
          #end
        #end
        #$oneNormalEdges = $oneNormalEdges.flatten.uniq
        #$twoNormalEdges = $twoNormalEdges.flatten.uniq
        #for e in $twoNormalEdges
          #@ss.add(e)
        #end
      ### End
    end
  ### End FlatTool class
end

class EraseEdgesTool
  def EraseEdgesTool::definitions
    ### Defining/clearing arrays, selection sets, and variables
      @ss = Sketchup.active_model.selection
      @trunk = []
    ### End
  end
  def EraseEdgesTool::go
    ### This runs through all the methods
      EraseEdgesTool.definitions
      #final_edges_to_sel
      EraseEdgesTool.retrieve_edges_from_sel
      #clear_edges_2_faces_caseC
      #clear_edges_0_faces
      #clear_edges_1_faces
      #clear_edges_2_faces_caseA
      #clear_edges_0_faces
    ### End
  end
  def EraseEdgesTool::final_edges_to_sel
      @ss.clear
      @finalEdges.each do |v|
        @ss.add(v)
      end
  end
  def EraseEdgesTool::retrieve_edges_from_sel
    ### If ent is an Edge object, add it to @trunk and then make an array of all Point3d objects
      for e in @ss
        if ((e.kind_of?(Sketchup::Edge)) && (not $twoNormalEdges.include?(e)))
          @trunk.push(e)
        end
      end
      @ss.clear
      for e in @trunk
        @ss.add(e)
      end
  end
  def EraseEdgesTool::clear_edges_0_faces
    ### If the edge is connected to 0 faces
      for e in @ss
        if(e.faces.uniq.length==0)
          e.erase!
        end
      end
    ### End
  end
  def EraseEdgesTool::clear_edges_1_faces
    ### If the edge is connected to 1 faces
      for e in @ss
        if(e.faces.uniq.length==1)
          e.erase!
        end
      end
    ### End
  end
  def EraseEdgesTool::clear_edges_2_faces_caseA
    ### If the edge is connected to 2 or more faces
      for e in @ss
        if(e.faces.length > 1)
          e.erase!
        end
      end
    ### End    
  end
  def EraseEdgesTool::clear_edges_2_faces_caseB
    ### If the edge is connected to 2 faces and the edge is connected to the outer edge loop
      for e in @ss
        if((not e.deleted?) && (e.faces.length>1))
          for v in e.vertices
            if (not v.deleted?)
              for n in v.faces
                if((not n.deleted?) && (n.normal != @n))
                  e.erase!
                end
              end
            end
          end
        end
      end
    ### End
  end
  def EraseEdgesTool::clear_edges_2_faces_caseC
    ### Another method for clearing that edge
      for e in @ss
        if (e.faces.length>1)
          for v in $twoNormalEdges
            if v.all_connected.include?(e)
              e.erase!
            end
          end
        end
      end
      for e in @finalEdges
        if (not e.deleted?)
          @ss.add(e)
        end
      end
    ### End
  end
end
if( not file_loaded?("FlatScript.rb") )
  UI.add_context_menu_handler do | menu | 
    if Sketchup.active_model.selection
      menu.add_separator
      menu.add_item("Flattening Script") { FlatTool.getverts }
    end
  end
end
file_loaded("FlatScript.rb")